<?php

namespace DoctrineMigrations;

use Doctrine\DBAL\Migrations\AbstractMigration;
use Doctrine\DBAL\Schema\Schema;
use Doctrine\ORM\EntityManager;
use Eccube\Entity\PageLayout;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
class Version20171234000000 extends AbstractMigration
{

    /**
     * @param Schema $schema
     */
    public function up(Schema $schema)
    {
        // this up() migration is auto-generated, please modify it to your needs
        $t = $schema->getTable('dtb_base_info');
        if (!$t->hasColumn('show_price01')) {
            $t->addColumn('show_price01', 'smallint', array('NotNull' => false, 'DEFAULT' => 1));
        }
        if (!$t->hasColumn('show_price02')) {
            $t->addColumn('show_price02', 'smallint', array('NotNull' => false, 'DEFAULT' => 1));
        }
        if (!$t->hasColumn('show_code')) {
            $t->addColumn('show_code', 'smallint', array('NotNull' => false, 'DEFAULT' => 1));
        }
        if (!$t->hasColumn('show_stock')) {
            $t->addColumn('show_stock', 'smallint', array('NotNull' => false, 'DEFAULT' => 1));
        }
        if (!$t->hasColumn('show_limit')) {
            $t->addColumn('show_limit', 'smallint', array('NotNull' => false, 'DEFAULT' => 1));
        }
        if (!$t->hasColumn('show_deliv')) {
            $t->addColumn('show_deliv', 'smallint', array('NotNull' => false, 'DEFAULT' => 1));
        }
        if (!$t->hasColumn('show_photo')) {
            $t->addColumn('show_photo', 'smallint', array('NotNull' => false, 'DEFAULT' => 1));
        }
        if (!$t->hasColumn('mypage_receipt')) {
            $t->addColumn('mypage_receipt', 'smallint', array('NotNull' => false, 'DEFAULT' => 0));
        }
        if (!$t->hasColumn('mypage_receipt_status')) {
            $t->addColumn('mypage_receipt_status', 'smallint', array('NotNull' => false));
        }

        $t = $schema->getTable('dtb_product');
        if (!$t->hasColumn('option_class')) {
            $t->addColumn('option_class', 'smallint', array('NotNull' => false));
        }
        if (!$t->hasColumn('seo_title')) {
            $t->addColumn('seo_title', 'text', array('NotNull' => false));
        }
        if (!$t->hasColumn('seo_author')) {
            $t->addColumn('seo_author', 'text', array('NotNull' => false));
        }
        if (!$t->hasColumn('seo_description')) {
            $t->addColumn('seo_description', 'text', array('NotNull' => false));
        }
        if (!$t->hasColumn('seo_keyword')) {
            $t->addColumn('seo_keyword', 'text', array('NotNull' => false));
        }
        if (!$t->hasColumn('seo_meta_robots')) {
            $t->addColumn('seo_meta_robots', 'text', array('NotNull' => false));
        }
        if (!$t->hasColumn('arrival_date')) {
            $t->addColumn('arrival_date', 'datetime', array('NotNull' => false));
        }
        if (!$t->hasColumn('endsell_date')) {
            $t->addColumn('endsell_date', 'datetime', array('NotNull' => false));
        }
        if (!$t->hasColumn('arrival_check')) {
            $t->addColumn('arrival_check', 'smallint', array('NotNull' => false));
        }
        if (!$t->hasColumn('endsell_check')) {
            $t->addColumn('endsell_check', 'smallint', array('NotNull' => false));
        }

        $t = $schema->getTable('dtb_category');
        if (!$t->hasColumn('seo_title')) {
            $t->addColumn('seo_title', 'text', array('NotNull' => false));
        }
        if (!$t->hasColumn('seo_author')) {
            $t->addColumn('seo_author', 'text', array('NotNull' => false));
        }
        if (!$t->hasColumn('seo_description')) {
            $t->addColumn('seo_description', 'text', array('NotNull' => false));
        }
        if (!$t->hasColumn('seo_keyword')) {
            $t->addColumn('seo_keyword', 'text', array('NotNull' => false));
        }
        if (!$t->hasColumn('seo_meta_robots')) {
            $t->addColumn('seo_meta_robots', 'text', array('NotNull' => false));
        }
        if (!$t->hasColumn('page_image')) {
            $t->addColumn('page_image', 'text', array('NotNull' => false));
        }

        $app = \Eccube\Application::getInstance();
        /** @var EntityManager $em */
        $em = $app["orm.em"];

        $DeviceType = $app['eccube.repository.master.device_type']->find(10);

        $PageLayout = new PageLayout();
        $PageLayout
            ->setDeviceType($DeviceType)
            ->setName('MYページ/領収書／購入明細書')
            ->setUrl('mypage_receipt')
            ->setFileName('Mypage/receipt')
            ->setEditFlg(2)
            ->setMetaRobots('noindex');
        $em->persist($PageLayout);

        $em->flush();
    }

    /**
     * @param Schema $schema
     */
    public function down(Schema $schema)
    {
    }

}
