<?php

namespace DoctrineMigrations;

use Doctrine\DBAL\Migrations\AbstractMigration;
use Doctrine\DBAL\Schema\Schema;
use Doctrine\ORM\EntityManager;
use Eccube\Application;
use Eccube\Common\Constant;
use Eccube\Entity\Csv;
use Eccube\Entity\Master\CsvType;
use Eccube\Entity\Master\Tag;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
class Version20171234000002 extends AbstractMigration
{

    private $csv_datas = array(
        array(
            'entity_name' => 'Eccube\\\\Entity\\\\Category',
            'field_name' => 'seo_title',
            'reference_field_name' => NULL,
            'disp_name' => 'title',
        ),
        array(
            'entity_name' => 'Eccube\\\\Entity\\\\Category',
            'field_name' => 'seo_author',
            'reference_field_name' => NULL,
            'disp_name' => 'author',
        ),
        array(
            'entity_name' => 'Eccube\\\\Entity\\\\Category',
            'field_name' => 'seo_description',
            'reference_field_name' => NULL,
            'disp_name' => 'description',
        ),
        array(
            'entity_name' => 'Eccube\\\\Entity\\\\Category',
            'field_name' => 'seo_keyword',
            'reference_field_name' => NULL,
            'disp_name' => 'keyword',
        ),
        array(
            'entity_name' => 'Eccube\\\\Entity\\\\Category',
            'field_name' => 'seo_meta_robots',
            'reference_field_name' => NULL,
            'disp_name' => 'meta_robots',
        ),
        array(
            'entity_name' => 'Eccube\\\\Entity\\\\Category',
            'field_name' => 'page_image',
            'reference_field_name' => NULL,
            'disp_name' => '画像',
        ),
    );

    /**
     * @param Schema $schema
     */
    public function up(Schema $schema)
    {
        $app = \Eccube\Application::getInstance();
        $em = $app['orm.em'];

        $this->dtb_csv($em);

        $em->flush();
    }

    /**
     * @param Schema $schema
     */
    public function down(Schema $schema)
    {
        $app = \Eccube\Application::getInstance();
        $em = $app['orm.em'];

        $this->delete_dtb_csv($em);

        $em->flush();
    }

    /**
     * insert dtb_csv
     *
     * @param EntityManager $em
     */
    private function dtb_csv(EntityManager $em)
    {
        $filter = $em->getFilters()->getFilter('soft_delete');
        $filter->setExcludes(array(
            'Eccube\Entity\Member'
        ));
        $CsvType = $em->getRepository('Eccube\Entity\Master\CsvType')->find(CsvType::CSV_TYPE_CATEGORY);
        $Member = $em->getRepository('Eccube\Entity\Member')->find(1);
        $Csv = $em->getRepository('Eccube\Entity\Csv')->findOneBy(
            array('CsvType' => $CsvType),
            array('rank' => 'DESC')
        );
        $rank = $Csv->getRank();

        foreach ($this->csv_datas as $data) {
            $rank++;

            $Csv = new Csv();
            $Csv
                ->setCsvType($CsvType)
                ->setCreator($Member)
                ->setEntityName($data['entity_name'])
                ->setFieldName($data['field_name'])
                ->setReferenceFieldName($data['reference_field_name'])
                ->setDispName($data['disp_name'])
                ->setRank($rank)
                ->setEnableFlg(Constant::ENABLED);

            $em->persist($Csv);
        }
    }

    /**
     * delete dtb_csv
     *
     * @param EntityManager $em
     */
    private function delete_dtb_csv(EntityManager $em)
    {
        $repository = $em->getRepository('Eccube\Entity\Csv');
        foreach ($this->csv_datas as $data) {
            $Csv = $repository->findOneBy(array(
                'entity_name' => $data['entity_name'],
                'field_name' => $data['field_name'],
                'reference_field_name' => $data['reference_field_name'],
            ));

            if ($Csv) {
                $em->remove($Csv);
            }
        }
    }
}